class FishTreesRun:
    def __init__(self):
        self.commandlinestr=""
        self.dicofprocesseddata=[]#check
        self.geneprobesnames=[]#check
        self.celltypenames=[]#check
        self.storetreeresult='tree'
        
def turnexceldatain2dlist(p):

    data=[]
    counter=0
    for row in p.iter_rows():

        #print type(row[0].value).__name__, type(row[0].value).__name__=='NoneType'
        if type(row[0].value).__name__=='NoneType':
            continue
        counter+=1
        if (counter%1000==0):print 'This many genes have been processed for all experiments:',counter
        tempdata=[]
        for colentry in row:
            if counter==2:
                if colentry.value!=None:
                    tempdata.append(str(colentry.value))
                else:tempdata.append(colentry.value)
            else:tempdata.append(colentry.value)
        data.append(tempdata)

    #remove empty cols        
    data1=zip(*data)
    data2=[]
    for i in data1:
        s=set(i)
        if len(s)==1:
            if None in s:
                continue
        data2.append(i)
    data=zip(*data2)
    print data
    return data

def pickrandommarkersubset(random,sizeofallfeatures,sizeofsubset):
    return sorted(random.sample(range(sizeofallfeatures),sizeofsubset))

def makeedgecounter(referencecelltypenames):
    """Function takes in a list of names and returns a dictionary of all unique pairs, that can be used to count occurrences of edges"""
    edgecounter={}
    numtypes=len(referencecelltypenames)
    for firsttype in xrange(numtypes):
        for secondtype in xrange(numtypes):
            if secondtype<firsttype:# this ensures that there are no effective copies of edges
                edgecounter[(referencecelltypenames[firsttype],referencecelltypenames[secondtype])]=0
    return edgecounter
    
def findfilename(os):
        #function to find ..dot files
        for st in os.listdir('.'):
            if 'treeinfishformat.txt..dot' in st:
                filetouse=st
                break
        try:return filetouse
        except:return None