import openpyxl as px
import time
import random
import os
import multiprocessing
import fishtreesrundatastructs as ftds
import networkx as nx
#from decisiontreeutilsforcancerphylo import *
import decisiontreeutilsforcancerphylo as dtufcp
from decisiontreeutilsforcancerphylo import node,treedata,nulllinetoinitiatenode

#%% 

cpcr=dtufcp.checkparentchildrelation

#%% 

print 'finding inital excel file'
#filename='preprocessMSdata.xlsx'#todo
filename='preprocessMSdata_byRuchi.xlsx'
#original tree A from 2005 paper in 2015
selectedsheet='tables2a_leavesonly'
#simpletest1
#selectedsheet='simpletest1'
#simpletest2
#selectedsheet='simpletest2'
#simpletest3
#selectedsheet='simpletest3'

W = px.load_workbook(filename, use_iterators = True)
p = W.get_sheet_by_name(name = selectedsheet)

print 'loading text data from excel file'
data= ftds.turnexceldatain2dlist(p)
print 'finished loading text data from excel file'
#%% 
cornerentry=data[0][0]
transposedata=zip(*data)
firstrow=list(transposedata[0])

reformateddata=[]
linecounter=0
for line in transposedata:
    if linecounter==1:
        linecounter+=1
        continue
    reformatedline=list(line)
    if linecounter==0:
        reformatedline=reformatedline[:1]+reformatedline[2:]
        reformateddata.append(reformatedline)
        linecounter+=1
        continue
    if (linecounter%2==0):
        firstcellrow=reformatedline[1:]
        print firstcellrow 
    elif (linecounter%2==1):
        secondcellrow=reformatedline[1:]
        assembledcellrow=[firstcellrow[0]]
        print secondcellrow
        print assembledcellrow
        #print len(assembledcellrow),len(reformatedline),assembledcellrow,reformatedline
        for pos in xrange(len(reformatedline[2:])):
            assembledcellrow.append(firstcellrow[pos+1]+secondcellrow[pos+1])
        print assembledcellrow
        reformateddata.append(assembledcellrow)
    linecounter+=1
    

def savedatatreesinappropriateformat(treenames=[],exceltables=[],prefix=""):
	"""Function that takes in a list of tree names and a list of tables and saevs them in an formated folder for further anaysis"""
	from string import ascii_uppercase;allletters=list(ascii_uppercase)
	def countforlevel(level):
		"""function that counts how many total letters combinations can be made from at most "level" chars at once"""
		assert((type(level).__name__)=='int')
		assert(level>-1)
		numofchars=26
		count=0
		for eachlevel in xrange(level+1):count+=numofchars**(eachlevel+1)
		return count
	def countnumlevelsrequired(count):
		"""function that determines how combinations of letters (in combination of at most "levelcounter" letters at once ) are needed to uniquely label all the cells you have"""
		levelcounter=0
		levelcount=countforlevel(levelcounter)
		while(count>levelcount):
			levelcounter+=1
			levelcount=countforlevel(levelcounter)
		return levelcounter
	def makecollabelsforexcel(level):
		"""function that returns a list of all column names that are used in a excel file in a recursive manner"""
		assert((type(level).__name__)=='int')
		assert(level>-1)
		if level==0:return list(allletters)
		else:
			newlabels=list(allletters)
			#counter=0
			priorlist=makecollabelsforexcel(level-1)
			for string in priorlist:
				for char in list(allletters):newlabels.append(''.join([string,char]))
		return newlabels
	def turntable2excelfile(datatable,filename,sheetname):
		"""function that takes in a data table as a 2d array like object and save that table in an excel file named "filename" in sheet "sheetname" """
		WW=px.Workbook()
		pp=WW.get_active_sheet()
		pp.title=sheetname
		# this functions make the column 'names' that excel uses
		levelforcols=countnumlevelsrequired(len(datatable[0]))
		excellabels=makecollabelsforexcel(levelforcols)
		# this actually saves the data to cells in an excel file
		for row in xrange(len(datatable)):
			for col in xrange(len(datatable[row])):
				pp.cell('%s%d'%(excellabels[col],row+1)).value=datatable[row][col]# necessary either way
		WW.save(filename)
	timestr=time.asctime(time.localtime());date= timestr.split(" ");date=" ".join(date[:3]+date[4:]);
	datadic={};datadic["treefolders"]=[];datadic["nameonlytreefilename"]=[];datadic["nameonlytree"]=[];datadic["newicktree"]=[];datadic["newicktreefilename"]=[];datadic["nameanddatatreefilename"]=[];datadic["nameanddatatree"]=[];datadic["dataonlytreefilename"]=[];datadic["dataonlytree"]=[];datadic["excelname"]=[];datadic["excelsheetname"]=[];datadic["datatonamemaping"]=[];datadic["onlyuniquecellsintree"]=[];
	datadic["compressedtreedata"]={};datadic["compressedtreedata"]["nameonlytreefilename"]=[];datadic["compressedtreedata"]["nameonlytree"]=[];datadic["compressedtreedata"]["newicktree"]=[];datadic["compressedtreedata"]["newicktreefilename"]=[];datadic["compressedtreedata"]["nameanddatatreefilename"]=[];datadic["compressedtreedata"]["nameanddatatree"]=[];datadic["compressedtreedata"]["dataonlytreefilename"]=[];datadic["compressedtreedata"]["dataonlytree"]=[];datadic["compressedtreedata"]["datatonamemaping"]=[];
	topdir=(prefix+"_processedandreformateddata_%s"+os.sep)%(date);datadic["datadir"]=topdir;
	if topdir[:-1] not in os.listdir("."):os.mkdir(topdir)
	os.chdir(topdir)
	workdir=("init_datasets"+os.sep);datadic["workdir"]=topdir+workdir
	if workdir[:-1] not in os.listdir("."):os.mkdir(workdir)
	os.chdir(workdir)
	readm="README.txt";readmfile=open(readm,"w");datadic["readmename"]=(topdir+workdir+"README.txt");
	readmfile.write("Data generation began on %s\n"%(timestr));readmfile.write("Make %d trees for the saved data found elswhere\n"%(len(treenames)));
	for tree in xrange(len(treenames)):#iteration=0#start loop##make a new tree each time run:
		iterfolder=("data_for_%s"+os.sep)%(treenames[tree])
		datadic["treefolders"].append((topdir+workdir+iterfolder))
		if iterfolder[:-1] not in os.listdir("."):os.mkdir(iterfolder)
		os.chdir(iterfolder)
		evotree=nx.Graph();datadic["nameonlytree"].append(evotree);
		datadic["datatonamemaping"].append({})                
		newickstring="None";datadic["newicktree"].append(newickstring);
		datadic["nameonlytreefilename"].append(None);
		datadic["newicktreefilename"].append(None);
		nameanddataevotree=nx.Graph();datadic["nameanddatatree"].append(nameanddataevotree);
		datadic["nameanddatatreefilename"].append(None);
		dataonlyevotree=nx.Graph();datadic["dataonlytree"].append(dataonlyevotree);
		#make tree where nodes with no identical cells
		datadic["onlyuniquecellsintree"].append(True)
		datadic["compressedtreedata"]["nameonlytreefilename"].append(None);datadic["compressedtreedata"]["nameonlytree"].append(None);datadic["compressedtreedata"]["newicktree"].append(None);datadic["compressedtreedata"]["newicktreefilename"].append(None);datadic["compressedtreedata"]["nameanddatatreefilename"].append(None);datadic["compressedtreedata"]["nameanddatatree"].append(None);datadic["compressedtreedata"]["dataonlytreefilename"].append(None);datadic["compressedtreedata"]["dataonlytree"].append(None);datadic["compressedtreedata"]["datatonamemaping"].append(None);
		#finally make excel 
		turntable2excelfile(exceltables[tree],"preprocessMSdataproperlyformateddatafor%s.xlsx"%(treenames[tree]),treenames[tree]);datadic["excelname"].append((datadic["treefolders"][-1])+"preprocessMSdataproperlyformateddatafor%s.xlsx"%(treenames[tree]));datadic["excelsheetname"].append(treenames[tree]);
		if ("preprocessMSdataproperlyformateddatafor%s.xlsx"%(treenames[tree])) in os.listdir("."): print "excel file was made"
		else: print "no file made"
		os.chdir("..")
		#end loop
	readmfile.close()
	import pickle;saveddatastructfile=open("saveddatastructs.pkl","w");pickle.dump(datadic,saveddatastructfile);saveddatastructfile.close()
	os.chdir("..");os.chdir("..");
	return datadic

savedatatreesinappropriateformat(treenames=['tables2a'],exceltables=[reformateddata],prefix="Frumkin2005_treea")

"""
wb=px.workbook.Workbook()
wb.active._title=selectedsheet

for rowpos in xrange(len(reformateddata)):
    for colpos in xrange(len(reformateddata[0])):
        wb.active.cell(row=rowpos+1,column=colpos+1).value=reformateddata[rowpos][colpos]    
        
wb.save(("properlyformateddatafor%s."%(selectedsheet)).join(filename.split(".")))"""
